## org.apache.cassandra.db.marshal
Class BytesType

    java.lang.Object
      org.apache.cassandra.db.marshal.AbstractType<java.nio.ByteBuffer>
          org.apache.cassandra.db.marshal.BytesType

All Implemented Interfaces:
  java.util.Comparator<java.nio.ByteBuffer>

    public class BytesType

extends AbstractType<java.nio.ByteBuffer>

Field Summary
`static BytesType` `instance`

Fields inherited from class org.apache.cassandra.db.marshal.AbstractType
`columnComparator, columnReverseComparator, indexComparator, indexReverseComparator, reverseComparator`

Method Summary
`static int` `bytesCompare(java.nio.ByteBuffer o1, java.nio.ByteBuffer o2)`
`int` `compare(java.nio.ByteBuffer o1, java.nio.ByteBuffer o2)`
`java.nio.ByteBuffer` `compose(java.nio.ByteBuffer bytes)`
`java.nio.ByteBuffer` `decompose(java.nio.ByteBuffer value)`
`java.nio.ByteBuffer` `fromString(java.lang.String source)` get a byte representation of the given string.
`java.lang.String` `getString(java.nio.ByteBuffer bytes)` get a string representation of the bytes suitable for log messages
`boolean` `isCompatibleWith(AbstractType<?> previous)` Returns true if this comparator is compatible with the provided previous comparator, that is if previous can safely be replaced by this.
`void` `validate(java.nio.ByteBuffer bytes)`

Methods inherited from class org.apache.cassandra.db.marshal.AbstractType
`getColumnsString, getReverseComparator, getString, isCommutative, parseDefaultParameters, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Comparator
`equals`

Field Detail

### instance

    public static final BytesType instance

Method Detail

### compose

    public java.nio.ByteBuffer compose(java.nio.ByteBuffer bytes)

  Specified by:
    `compose` in class `AbstractType<java.nio.ByteBuffer>`

### decompose

    public java.nio.ByteBuffer decompose(java.nio.ByteBuffer value)

  Specified by:
    `decompose` in class `AbstractType<java.nio.ByteBuffer>`

### compare

    public int compare(java.nio.ByteBuffer o1,
                       java.nio.ByteBuffer o2)

### bytesCompare

    public static int bytesCompare(java.nio.ByteBuffer o1,
                                   java.nio.ByteBuffer o2)

### getString

    public java.lang.String getString(java.nio.ByteBuffer bytes)

  Description copied from class: `AbstractType`
  get a string representation of the bytes suitable for log messages

  Specified by:
    `getString` in class `AbstractType<java.nio.ByteBuffer>`

### fromString

    public java.nio.ByteBuffer fromString(java.lang.String source)

  Description copied from class: `AbstractType`
  get a byte representation of the given string.

  Specified by:
    `fromString` in class `AbstractType<java.nio.ByteBuffer>`

### validate

    public void validate(java.nio.ByteBuffer bytes)
                  throws MarshalException

  Specified by:
    `validate` in class `AbstractType<java.nio.ByteBuffer>`
  Throws:
    `MarshalException`

### isCompatibleWith

    public boolean isCompatibleWith(AbstractType<?> previous)

  Description copied from class: `AbstractType`
  Returns true if this comparator is compatible with the provided previous comparator, that is if previous can safely be replaced by this. A comparator cn should be compatible with a previous one cp if forall columns c1 and c2, if cn.validate(c1) and cn.validate(c2) and cn.compare(c1, c2) == v, then cp.validate(c1) and cp.validate(c2) and cp.compare(c1, c2) == v. Note that a type should be compatible with at least itself and when in doubt, keep the default behavior of not being compatible with any other comparator!

  Overrides:
    `isCompatibleWith` in class `AbstractType<java.nio.ByteBuffer>`

Copyright © 2013 The Apache Software Foundation